React UI Components Documentation
Typescript React Knob Component
This tutorial will show you the basics of how to get started with the jQWidgets Knob React Component.
Prerequisites
Refer to Getting Started with React before you start with this help topic.
Structure
I. Imports:
import * as React from 'react'; import 'jqwidgets-scripts/jqwidgets/styles/jqx.base.css';import 'jqwidgets-scripts/jqwidgets/styles/jqx.material-purple.css';import JqxKnob, { IKnobProps } from 'jqwidgets-scripts/jqwidgets-react-tsx/jqxknob';
II. Class:
class App extends React.PureComponent<{}, IKnobProps> { constructor(props: {}) { super(props); this.state = { width: '100%' // Other Widget Props } } render() { return ( <JqxKnob width={this.state.width} height={"100%"} ..... /> ) }}
III. Render:
ReactDOM.render(<App />, document.getElementById('app'));
Events
The event names in React are constructed of the original event names starting with capital letter plus on upfront:
class App extends React.PureComponent<{}, IKnobProps> { constructor(props: {}) { super(props); this.state = { width: '100%' // Other Widget Props } } render() { return ( <JqxKnob onNameOfEvent={this.handleEvent} width={this.state.width} height={"100%"} ..... /> ) } private handleEvent(e: Event): void { // Do Something ... }}
Methods & Properties
This is how you call methods & props:
//Get Methodsconst value = this.myKnob.current!.methodName(arg1, arg2); //Set Methodsthis.myKnob.current!.methodName(arg1, arg2); //Get Propertiesconst height = this.state.height; //Set Propertiesthis.setState({ height: 250 });
Every component have a method setOptions which accepts a object as an argument. This object contains component settings.
this.myKnob.current!.setOptions({ width: 350, height: 400 });
Every component also have a method getOptions which returns the value of the requested option.
const width = this.myKnob.current!.getOptions('width');
Knob API
API Reference of the jQWidgets Knob React Component: Knob API
Knob Demos
Demos Reference of the jQwidgets Knob React Component: Knob Demos

Angular Knob Component

The Knob component for Angular represents a plugin with round shape which displays a draggable indicator within a range of values.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<div id="container">

    <jqxKnob #myKnob (onChange)="onChange($event)"
        [value]="60" [min]="0" [max]="100" [startAngle]="120"
        [endAngle]="420" [snapToStep]="true" [rotation]="'clockwise'" [style]="style"
        [marks]="marks" [labels]="labels" [progressBar]="progressBar" [pointer]="pointer">
    </jqxKnob>

    <div id="inputField">

        <jqxNumberInput [theme]="'fluent'" #myNumberInput
            (mousedown)="onMouseDown($event)" (keyup)="onKeyup()" (onValueChanged)="onValueChanged()"
            [width]="60" [height]="40" [decimal]="60" [min]="0" [max]="100"
            [textAlign]="'center'" [decimalDigits]="1" [inputMode]="'simple'">
        </jqxNumberInput>

    </div>
</div>	

3. Setup Component Logic

app.component.ts


import { Component, ViewChild, ViewEncapsulation } from '@angular/core';

import { jqxKnobComponent } from 'jqwidgets-scripts/jqwidgets-ts/angular_jqxknob.ts';
import { jqxNumberInputComponent } from 'jqwidgets-ng/jqxnumberinput';

import { jqxKnobModule, jqxKnobComponent } from 'jqwidgets-ng/jqxknob';
@Component({
    selector: 'app-root',
    imports: [jqxKnobModule],
    standalone: true,
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css'],
    encapsulation: ViewEncapsulation.None
})

export class AppComponent {
    @ViewChild('myKnob') myKnob: jqxKnobComponent;
    @ViewChild('myNumberInput') myNumberInput: jqxNumberInputComponent;

    style: any =
        {
            stroke: '#dfe3e9', strokeWidth: 3,
            fill: {
                color: '#fefefe', gradientType: "linear",
                gradientStops: [[0, 1], [50, 0.9], [100, 1]]
            }
        };

    marks: any =
        {
            colorRemaining: { color: 'grey', border: 'grey' },
            colorProgress: { color: '#00a4e1', border: '#00a4e1' },
            type: 'line', offset: '71%', thickness: 3, size: '6%',
            majorSize: '9%', majorInterval: 10, minorInterval: 2
        };

    labels: any =
        {
            offset: '88%',
            step: 10,
            visible: true
        };

    progressBar: any =
        {
            style: { fill: '#00a4e1', stroke: 'grey' },
            size: '9%', offset: '60%',
            background: { fill: 'grey', stroke: 'grey' }
        };

    pointer: any =
        {
            type: 'arrow', style: { fill: '#00a4e1', stroke: 'grey' },
            size: '59%', offset: '49%', thickness: 20
        };

    onChange(event: any): void {
        if (event.args.changeSource == 'propertyChange' || event.args.changeSource == 'val') { return; }
        this.myNumberInput.val(event.args.value);
    }

    onMouseDown(event: any): void {
        event.stopPropagation();
    }

    onKeyup(): void {
        let val = this.myNumberInput.val();
        this.myKnob.val(val);
    }

    onValueChanged(): void {
        let val = this.myNumberInput.val();
        this.myKnob.val(val);
    }
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

Knob API

API Reference of the jQWidgets Knob component for Angular: Knob API